/*----------------------------------------------------------------------------
 Copyright:      Wolfgang Scherr
 Author:         Wolfgang Scherr
 Remarks:        
 known Problems: 
 Version:        15.02.2009
 Description:    PS2 Keyboard Support

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#ifndef _PS2KB_H
	#define _PS2KB_H

#if !USE_PS2KB
	#if USE_PS2KB_STREAM
		#warning "PS2KB disabled, but streaming to it enabled - check config!"
		//without PS2KB, a stream also makes no sense...
		#undef USE_PS2KB_STREAM
		#define USE_PS2KB_STREAM 0
	#endif
#else

	#if !USE_TIMER
		#error "Timer support must be enabled (USE_TIMER=1)!"
	#endif
	
	extern unsigned char kb_rx_buffer;
	
	typedef struct {
			volatile unsigned char kb_ready:1;
			} KB_ITEM;
	
	extern KB_ITEM kb_status;
	
	//----------------------------------------------------------------------------
	
	#if defined (__AVR_ATmega32__)
		#define INTPOL MCUCR
		#define INTREG GICR
		#if PS2KB_CLK_INT == 0
			//trigger on rising INT0
			#define BIT_INTPOL (1<<ISC01)|(1<<ISC00)
			#define BIT_INTEN (1<<INT0)
			#define PS2KB_CLKINT INT0_vect
		#elif PS2KB_CLK_INT == 1
			//trigger on rising INT1
			#define BIT_INTPOL (1<<ISC11)|(1<<ISC10)
			#define BIT_INTEN (1<<INT1)
			#define PS2KB_CLKINT INT1_vect
		#elif PS2KB_CLK_INT == 2
			//trigger on rising/falling INT2
			#define BIT_INTEN (1<<INT2)
			#define PS2KB_CLKINT INT2_vect
		#else
			#error "Illegal Clock Interrupt" 
		#endif

	#endif
	
	#ifndef INTREG
		#error "Prozessortyp vom PS2-Code (noch) nicht untersttzt!"
	#endif
	//----------------------------------------------------------------------------
	
	void kb_init(void); 
	
	//----------------------------------------------------------------------------

	#if USE_PS2KB_STREAM
	// In stream mode, fscanf(&uart_stream,....) can be used.	
		extern FILE kb_stream;
		char kb_ischar(void);
	#endif

#endif //USE_PS2KB

#endif //_PS2KB_H
