/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich, reworked by Wolfgang Scherr
 Remarks:        Rework: config.h, alle Codeabhngigkeiten entfernt:
				 Zeitgesteuerte Flags & API zur "allgemeinen" Bedienung,
				 Watchdogs zum Auslsen von Neustarts
 known Problems: none
 Version:        14.02.2009
 Description:    Timer Routinen

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#ifndef _TIMER_H
  #define _TIMER_H

  #if USE_TIMER

	#if defined (__AVR_ATmega644__) || defined (__AVR_ATmega644P__)
		#define TIMSK TIMSK1
	#endif 

	extern volatile unsigned long time;

	void timer_init (void);

	typedef struct {
		unsigned long cnt;
		unsigned long reload;
		unsigned char wd_id;
		unsigned char *flag;
	} TFLAG_ITEM;
	
	//bergibt pointer an ein Flag (typ char), welches nach angegebener
	//Zeit (in Sekunden) gesetzt wird (Rckgabewert ist eine Flag-ID)
	//(Wenn -1 rckgegeben wird, ist der Flag-Puffer voll)
	int add_timer_flag (unsigned char*,unsigned long);
	//Lscht Flaghandling fe ein angegebenes Flag-ID
	void del_timer_flag (int);
 
	//Initialisiert einen Reset-Watchdog. Eine eindeutige ID (typ char) 
	//muss bergeben werden. Dies ist fr Highlevel-Timeouts interessant,
	//kann aber einen richtigen HW-Watchdog nicht ersetzen!
	//(Wenn -1 rckgegeben wird, ist der Flag-Puffer voll oder die ID ist vergeben)
 	int add_watchdog (unsigned char,unsigned long);
	//Gegebene Watchdog-ID rcksetzen.
	void reset_watchdog(unsigned char);

	//Timerwert setzen/lesen (kennte man auch mit inline function machen)
	#define set_time(t) { time=t; }
	#define get_time() time

  #endif //USE_TIMER
 
#endif //_TIMER_H

