/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Thomas, reworked by Wolfgang Scherr
 Remarks:        
 known Problems: none
 Version:        23.01.2008
 Description:    WOL

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#include "config.h"

#if USE_WOL

	#include "stack.h"
	#include "wol.h"

#if WOL_DEBUG
	#warning "Debugging of WOL application"
	#include "stdio.h"
	#define WOL_DEBUGP printf
#else
	#define WOL_DEBUGP(...)
#endif

//----------------------------------------------------------------------------
//MagicPacket versenden (immer 102 Byte)
void wol_request (unsigned char *mac)
{
        unsigned int byte_count;
		unsigned char bcast_ip[4];

		//Broadcast-Adresse bauen
		for (byte_count=0; byte_count < 4; byte_count++) {
			//Bits bei Netmask==1 enstprechen IP
			bcast_ip[byte_count]=myip[byte_count] & netmask[byte_count];
			//Bits bei Netmask==0 sind 1
			bcast_ip[byte_count]|=~netmask[byte_count];			
		}

		//sync stream erstellen (sechs mal FF)
		for (byte_count=0; byte_count < 6; byte_count++)
		{
			eth_buffer[UDP_DATA_START + byte_count] = 0xFF;
			
		}
        //16 mal die MAC-Adresse anhngen / darauf achten, dass nicht zu viel auf dem buffer landet
		for (; byte_count < 102 && byte_count < (MTU_SIZE-(UDP_DATA_START));)
		{
			for (unsigned char i=0; i < 6; i++)
			{
				eth_buffer[UDP_DATA_START + byte_count] = mac[i];
				byte_count++;
			}
		}
		create_new_udp_packet(byte_count,WOL_PORT,WOL_PORT,(*(unsigned long*)&bcast_ip[0]));
		
		WOL_DEBUGP("** MagicPacket an: %1i.%1i.%1i.%1i (%2x-%2x-%2x-%2x-%2x-%2x)**\r\n",
											bcast_ip[0],bcast_ip[1],bcast_ip[2],bcast_ip[3],
											mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
		return;

}
#endif //USE_WOL






