/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Webserver Applikation
 
 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/


#if USE_HTTPD

#ifndef _HTTPD_H
	#define _HTTPD_H
	
	typedef struct
	{
		char *auth_ptr;
		PGM_P hdr_end_pointer;
		PGM_P old_page_pointer;
		PGM_P new_page_pointer;
		char file_name[MAX_FILENAME_SIZE];
		unsigned int new_filepos;
		unsigned int old_filepos;
		char file_type[MAX_FILETYPE_SIZE];
		unsigned char var_cnt;
		char var_name[MAX_NAME_SIZE];
		char var_value[MAX_VAL_SIZE];
		unsigned char first		 		: 1		;
		unsigned char http_auth 		: 1		;
		unsigned char http_header_type	: 1		;
		unsigned char post				: 1		;
		unsigned char post_name			: 1		;
		unsigned char post_val			: 1		;
		unsigned char send_file			: 1		;
	} HTTP_ITEM;

	//Prototypen
	void httpd (unsigned char);
	void httpd_init (char(*)(char *, char *),char(*)(char, char *,char *),
	                 unsigned int(*)(char *,char *,unsigned int,unsigned int));
	
	void httpd_stack_clear (unsigned char);
	void httpd_header_check (unsigned char);
	void httpd_header_send (unsigned char, PGM_P);
	void httpd_data_send (unsigned char);
 
#endif //_HTTPD_H

#endif //USE_HTTPD
