/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich, reworked by Wolfgang Scherr
 Remarks:        
 known Problems: locks up from time to time...
 Version:        24.10.2007
 Description:    Webserver Applikation

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#include "config.h"

#if USE_TELNET

	#include <avr/pgmspace.h>
	#include "stack.h"
	#include <stdio.h>
	
#if TELNET_DEBUG
	#warning "Debugging of Telnet daemon"
	#define TELNET_DEBUGP printf
#else
	#define TELNET_DEBUGP(...)
#endif

	#include "telnetd.h"

//Not very efficient. Consider rework.
#if USE_TELNET_STREAM
	volatile unsigned char telnet_buf_in = 0;
	volatile unsigned char telnet_buf_out = 0;
#endif
char telnet_rx_buffer[TELNET_BUFFER_SIZE];
char telnet_tx_buffer[TELNET_BUFFER_SIZE];

TELNET_ITEM telnetd_status; //[MAX_TCP_ENTRY];

//----------------------------------------------------------------------------
//Initialisierung des telnetd Daemons
void telnetd_init (void)
{
	//Serverport und Anwendung in TCP Anwendungsliste eintragen
	add_tcp_app (TELNET_APP_PORT, (void(*)(unsigned char))telnetd);
	
	telnetd_status.telnet_open=0;
}

//----------------------------------------------------------------------------
//send on open telnet port
void telnetd_send_data (void)
{
	TELNET_DEBUGP("TD_SEND %1i\n",telnetd_status.tx_buf_size);

	unsigned char index;
	if (telnetd_status.data_sent)
	{
		TELNET_DEBUGP("-->FIND INDEX\n");
		for (index = 0;index<MAX_TCP_ENTRY;index++)
		{
			if(tcp_entry[index].dest_port == HTONS(23))
			{
				TELNET_DEBUGP("-->%d\n",index);
				if(!telnetd_status.ack_wait)
					{
					telnetd_status.ack_wait = 1;
					telnetd_status.data_sent=0;
					unsigned int count = 0;
					
					TELNET_DEBUGP("-->OUT\n");
					while(count<telnetd_status.tx_buf_size)
					{
						eth_buffer[TCP_DATA_START+count] = telnet_tx_buffer[count];
						count++;
					}
					tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
					create_new_tcp_packet(count,index);
					tcp_entry[index].time = TCP_MAX_ENTRY_TIME;
					return;
				}
				else
				{
					return;
				}
			}
		}
		if (index >= MAX_TCP_ENTRY)
		{
			TELNET_DEBUGP("Telnet: overflow\n");
		}
	}
}

//----------------------------------------------------------------------------
//telnet server daemon
void telnetd (unsigned char index)
{
    //Verbindung wurde abgebaut!
    if (tcp_entry[index].status & FIN_FLAG)
    {
		TELNET_DEBUGP("TELNET beendet\n");
		telnetd_status.telnet_open=0;
        return;
    }
    
	if (tcp_entry[index].app_status == 0 || tcp_entry[index].app_status == 1)
	{
		TELNET_DEBUGP("TELNET gestartet\n");
		tcp_entry[index].app_status = 1; 
		memcpy_P(&eth_buffer[TCP_DATA_START],PSTR("Telnet:\n"),9);
		create_new_tcp_packet(9,index);
		telnetd_status.ack_wait = 0;
		telnetd_status.data_sent = 1;
		#if !USE_TELNET_STREAM
			telnetd_status.rx_buf_size = 0;
			telnetd_status.telnet_ready=0;
		#else
			telnet_buf_in=0;
			telnet_buf_out=0;
		#endif
		telnet_rx_buffer[0] = 0;
		telnet_tx_buffer[0] = 0;
		telnetd_status.telnet_open=1;
		tcp_entry[index].time = TCP_TIME_OFF;
		return;
	}	

	if ((tcp_entry[index].app_status > 1) && (tcp_entry[index].status&PSH_FLAG))
	{	
		tcp_entry[index].app_status = 2;
		
  		for (int a = TCP_DATA_START_VAR;a<(TCP_DATA_END_VAR);a++)
		{
            unsigned char receive_char;
            receive_char = eth_buffer[a];

            #if !USE_TELNET_STREAM
                if (receive_char == IAC) {
					// We can not handle telnet commands, so we ignore 
					// them (in principle telnet data must be 7 bit!!!)
					// See: RFC854 or the nice work: The TELNET Protocol 
					// on http://support.microsoft.com/kb/231866/en-us
					a+=2;	//Structure to ignore is "IAC <Command> <Option>"
				}
                else if (receive_char == 0x08)
                {
                    if (buffercounter) buffercounter--;
                }
                else if (receive_char == '\r' && (!(telnet_rx_buffer[buffercounter-1] == '\\')))
                {
                    telnet_rx_buffer[buffercounter] = 0;
                    break;    
                }
                else if (buffercounter < TELNET_BUFFER_SIZE - 1)
                {
                    telnet_rx_buffer[buffercounter++] = receive_char;    
                }
            #else
				//Forward everything to the application 
				if ((telnet_buf_in==(telnet_buf_out+1)) || (telnet_buf_out==(TELNET_BUFFER_SIZE-1) && telnet_buf_in==0)) {
					// OVL!!!
					return;
				}
				
				telnet_rx_buffer[telnet_buf_out++] = receive_char;
				if (telnet_buf_out==TELNET_BUFFER_SIZE) telnet_buf_out=0;

			#endif
		}
		TELNET_DEBUGP("TD_REC %i\n",(TCP_DATA_END_VAR)-(TCP_DATA_START_VAR));
        #if !USE_TELNET_STREAM
			telnetd_status.telnet_ready = 1;
			telnetd_status.rx_buf_size = buffercounter;
		#endif
		tcp_entry[index].status =  ACK_FLAG;
		create_new_tcp_packet(0,index);
		return;
	}
	
	//Ack erhalten vom gesendeten Packet
	if ((tcp_entry[index].app_status > 1)&&(tcp_entry[index].status&ACK_FLAG)&&
	    (telnetd_status.ack_wait))
	{
		tcp_entry[index].time = TCP_TIME_OFF;
		telnetd_status.data_sent = 1;
		telnetd_status.ack_wait = 0;
		telnetd_status.tx_buf_size=0;
		return;
	}
	
	//Time out - kein ack angekommen
	if (tcp_entry[index].status == 0) 
	{
		//Daten nochmal senden
		telnetd_status.ack_wait = 0;
		telnetd_send_data ();
		return;
	}
	
	return;
}

#if USE_TELNET_STREAM
	//This display supports libc printf with scrolling, etc.
	int telnet_putchar(char c, FILE *stream) {

		//We can only send if the channel is open and no transmission is pending!
		if (!telnetd_status.telnet_open) {
			TELNET_DEBUGP("Putchar with closed port!\n");
			//no port open, we "swallow" the transmission
			return 0;
		} else {
			while ( (!telnetd_status.data_sent) && (telnetd_status.ack_wait) );
		}
		telnet_tx_buffer[telnetd_status.tx_buf_size++]=c;
		
		//We send if the buffer is full or 0a is reached.
		if ((c==0x0a) || (telnetd_status.tx_buf_size==TELNET_BUFFER_SIZE) ){
			telnetd_send_data();
		}
		return 0;
	}

	//Check for data available;
	char telnet_ischar(void) {
		return (telnetd_status.telnet_open && (telnet_buf_in!=telnet_buf_out));
	}

	//This display supports libc scanf etc.
	int telnet_getchar(FILE *stream) {
		char c;

		while(!telnet_ischar());
		c=telnet_rx_buffer[telnet_buf_in++];
		if (telnet_buf_in==TELNET_BUFFER_SIZE) telnet_buf_in=0;

		return c;
	}
	FILE telnet_stream = FDEV_SETUP_STREAM(telnet_putchar, telnet_getchar, _FDEV_SETUP_RW);
#endif

#endif //USE_TELNET
