/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich, reworked by Wolfgang Scherr
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Telnet Daemon

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#ifndef _TELNETD_H
	#define _TELNETD_H

#if !USE_TELNET
	#if USE_TELNET_STREAM
		#warning "TELNET disabled, but streaming to it enabled - check config!"
		//without USE_TELNET, a stream also makes no sense...
		#undef USE_TELNET_STREAM
		#define USE_TELNET_STREAM 0
	#endif
#else
    
	//Telnet protocol definitions
	#define IAC 0xFF    //"Interpret As Command"
	
	extern char telnet_rx_buffer[TELNET_BUFFER_SIZE];
	extern char telnet_tx_buffer[TELNET_BUFFER_SIZE];

	//Prototypen
	void telnetd_init (void);
	void telnetd (unsigned char);
 
	typedef struct {
			volatile unsigned int tx_buf_size;
		#if !USE_TELNET_STREAM
			volatile unsigned int rx_buf_size;
			volatile unsigned char telnet_ready	: 1;
		#endif
			volatile unsigned char telnet_open	: 1;
			volatile unsigned char data_sent	: 1;
			volatile unsigned char ack_wait	    : 1;
	} TELNET_ITEM;
 
	//----------------------------------------------------------------------------

	#if USE_TELNET_STREAM
	// In stream mode, fprintf(&telnet_stream,....) and fscanf(&telnet_stream,....) can be used.	
		extern FILE telnet_stream;
		char telnet_ischar(void);
	#else
		extern TELNET_ITEM telnetd_status;
		void telnetd_send_data (void);
	#endif
#endif //USE_TELNET
 
#endif //_TELNETD_H




